Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents lstItems As System.Windows.Forms.ListBox
    Friend WithEvents radByName As System.Windows.Forms.RadioButton
    Friend WithEvents radById As System.Windows.Forms.RadioButton
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.lstItems = New System.Windows.Forms.ListBox
        Me.radByName = New System.Windows.Forms.RadioButton
        Me.radById = New System.Windows.Forms.RadioButton
        Me.SuspendLayout()
        '
        'lstItems
        '
        Me.lstItems.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.lstItems.Location = New System.Drawing.Point(0, 0)
        Me.lstItems.Name = "lstItems"
        Me.lstItems.Size = New System.Drawing.Size(120, 212)
        Me.lstItems.TabIndex = 0
        '
        'radByName
        '
        Me.radByName.Location = New System.Drawing.Point(128, 8)
        Me.radByName.Name = "radByName"
        Me.radByName.TabIndex = 1
        Me.radByName.Text = "By Name"
        '
        'radById
        '
        Me.radById.Location = New System.Drawing.Point(128, 40)
        Me.radById.Name = "radById"
        Me.radById.TabIndex = 2
        Me.radById.Text = "By ID"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(240, 213)
        Me.Controls.Add(Me.radById)
        Me.Controls.Add(Me.radByName)
        Me.Controls.Add(Me.lstItems)
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private m_Items(9) As CustomerInfo

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Make some data.
        m_Items(0) = New CustomerInfo("Archer", 4)
        m_Items(1) = New CustomerInfo("Beck", 7)
        m_Items(2) = New CustomerInfo("Cantu", 2)
        m_Items(3) = New CustomerInfo("Deevers", 1)
        m_Items(4) = New CustomerInfo("Edwards", 9)
        m_Items(5) = New CustomerInfo("Finnagan", 3)
        m_Items(6) = New CustomerInfo("Guy", 5)
        m_Items(7) = New CustomerInfo("Hennesey", 8)
        m_Items(8) = New CustomerInfo("Irving", 6)
        m_Items(9) = New CustomerInfo("Jacquinth", 4)
        '' Uncomment to test duplicate objects.
        'm_Items(6) = New CustomerInfo("Finnagan", 3)
        'm_Items(7) = New CustomerInfo("Edwards", 9)
        'm_Items(8) = New CustomerInfo("Finnagan", 3)
        'm_Items(9) = New CustomerInfo("Deevers", 1)

        ' Start sorting by name.
        radByName.Checked = True
    End Sub

    ' Holds data.
    Private Class CustomerInfo
        Public Name As String
        Public ID As Integer        ' We sort on this value.

        Public Sub New(ByVal new_name As String, ByVal new_id As Integer)
            Name = new_name
            ID = new_id
        End Sub

        Public Overrides Function ToString() As String
            Return ID.ToString() & ". " & Name
        End Function
    End Class

    ' Compares CustomerInfo objects for sorting.
    Private Class CustomerInfoComparer
        Implements IComparer

        ' Determines whether we compare by name or ID.
        Public Enum CompareTypes
            ByName
            ById
        End Enum
        Public CompareType As CompareTypes = CompareTypes.ById
        Public Sub New(ByVal compare_type As CompareTypes)
            CompareType = compare_type
        End Sub

        ' Compare two CustomerInfo objects.
        Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare
            Dim x_cust As CustomerInfo = DirectCast(x, CustomerInfo)
            Dim y_cust As CustomerInfo = DirectCast(y, CustomerInfo)

            Select Case CompareType
                Case CompareTypes.ById
                    Return x_cust.ID.CompareTo(y_cust.ID)
                Case CompareTypes.ByName
                    Return x_cust.Name.CompareTo(y_cust.Name)
            End Select
        End Function
    End Class

    ' Sort by name.
    Private Sub radByName_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radByName.CheckedChanged
        If radByName.Checked Then SortBy(CustomerInfoComparer.CompareTypes.ByName)
    End Sub

    ' Sort by ID.
    Private Sub radById_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radById.CheckedChanged
        If radById.Checked Then SortBy(CustomerInfoComparer.CompareTypes.ById)
    End Sub

    ' Sort by name or ID.
    Private Sub SortBy(ByVal compare_type As CustomerInfoComparer.CompareTypes)
        ' Sort.
        Dim cust_comparer As New CustomerInfoComparer(compare_type)
        Array.Sort(m_Items, cust_comparer)

        ' Display the items.
        lstItems.Items.Clear()
        For i As Integer = 0 To m_Items.Length - 1
            lstItems.Items.Add(m_Items(i).ToString())
        Next i
    End Sub
End Class
